addpath('CAL')

DATAFILES = ['CAL/DEMAG_SET073_PROCESSED.mat';
             'CAL/DEMAG_SET077_PROCESSED.mat';
             'CAL/DEMAG_SET081_PROCESSED.mat';
             'CAL/DEMAG_SET086_PROCESSED.mat';
             'CAL/DEMAG_SET094_PROCESSED.mat';
             'CAL/DEMAG_SET096_PROCESSED.mat';
             'CAL/DEMAG_SET119_PROCESSED.mat';
             'CAL/DEMAG_SET122_PROCESSED.mat'];
         
HEAT_LEAKS = ['CAL/DEMAG_SET073_HEAT_LEAK_DYNAMIC.mat';
              'CAL/DEMAG_SET077_HEAT_LEAK_DYNAMIC.mat';
              'CAL/DEMAG_SET081_HEAT_LEAK_DYNAMIC.mat';
              'CAL/DEMAG_SET086_HEAT_LEAK_DYNAMIC.mat';
              'CAL/DEMAG_SET094_HEAT_LEAK_DYNAMIC.mat';
              'CAL/DEMAG_SET096_HEAT_LEAK_DYNAMIC.mat';
              'CAL/DEMAG_SET119_HEAT_LEAK_DYNAMIC.mat';
              'CAL/DEMAG_SET122_HEAT_LEAK_DYNAMIC.mat'];

RATE = zeros(8,1);
Q    = zeros(8,1);          
          
for i = 1:length(DATAFILES(:,1))

load(DATAFILES(i,:))
load(HEAT_LEAKS(i,:))

RES_LEAK(RES_LEAK==0)=[];

RATE(i) = (MEAS(1,2)-MEAS(1e4,2))/(MEAS(1e4,1)*60);
Q(i)    = mean(RES_LEAK);

end

plot(RATE,Q,'o')
xlabel('Field Ramp Rate (mT/s)')
ylabel('Average Heat Leak (W)')