#some of the usual cruft
import numpy as np
#import pandas as pd
import scipy, scipy.constants
e = scipy.constants.e
k_B = scipy.constants.Boltzmann
k= k_B
#import matplotlib.pyplot as plt
#import mjsplot as mplt
#import scipy.stats

#from renderjson import RenderJSON
#from IPython.core.display import display, HTML
#display(HTML("<style>.container { width:100% !important; }</style>"))

'''
Gt is the conductance of a cbt array
v is the dc voltage over the array


'''

def h(x):
    return x/np.tanh(x/2.0)
def hp(x):
    return -x/(2*np.sinh(x/2)**2)+1.0/np.tanh(x/2)
def g(x):
    return (x*np.sinh(x) - 4*np.sinh(x/2)**2)/(8*np.sinh(x/2)**4)
def gp(x):
    return -(x*np.sinh(x) - 4*np.sinh(x/2)**2)*np.cosh(x/2)/(4*np.sinh(x/2)**5) + (x*np.cosh(x) - 4*np.sinh(x/2)*np.cosh(x/2) + np.sinh(x))/(8*np.sinh(x/2)**4)
def gpp(x):
    return -(x*np.sinh(x) - 4*np.sinh(x/2)**2)/(8*np.sinh(x/2)**4) + 5*(x*np.sinh(x) - 4*np.sinh(x/2)**2)*np.cosh(x/2)**2/(8*np.sinh(x/2)**6) - (x*np.cosh(x) - 4*np.sinh(x/2)*np.cosh(x/2) + np.sinh(x))*np.cosh(x/2)/(2*np.sinh(x/2)**5) + (x*np.sinh(x) - 2*np.sinh(x/2)**2 - 2*np.cosh(x/2)**2 + 2*np.cosh(x))/(8*np.sinh(x/2)**4)
def gppp(x):
    return 7*(x*np.sinh(x) - 4*np.sinh(x/2)**2)*np.cosh(x/2)/(8*np.sinh(x/2)**5) - 15*(x*np.sinh(x) - 4*np.sinh(x/2)**2)*np.cosh(x/2)**3/(8*np.sinh(x/2)**7) - 3*(x*np.cosh(x) - 4*np.sinh(x/2)*np.cosh(x/2) + np.sinh(x))/(8*np.sinh(x/2)**4) + 15*(x*np.cosh(x) - 4*np.sinh(x/2)*np.cosh(x/2) + np.sinh(x))*np.cosh(x/2)**2/(8*np.sinh(x/2)**6) + (x*np.cosh(x) - 4*np.sinh(x/2)*np.cosh(x/2) + 3*np.sinh(x))/(8*np.sinh(x/2)**4) - 3*(x*np.sinh(x) - 2*np.sinh(x/2)**2 - 2*np.cosh(x/2)**2 + 2*np.cosh(x))*np.cosh(x/2)/(4*np.sinh(x/2)**5)
def gpppp(x):
    return 7*(x*np.sinh(x) - 4*np.sinh(x/2)**2)/(16*np.sinh(x/2)**4) - 5*(x*np.sinh(x) - 4*np.sinh(x/2)**2)*np.cosh(x/2)**2/np.sinh(x/2)**6 + 105*(x*np.sinh(x) - 4*np.sinh(x/2)**2)*np.cosh(x/2)**4/(16*np.sinh(x/2)**8) + 7*(x*np.cosh(x) - 4*np.sinh(x/2)*np.cosh(x/2) + np.sinh(x))*np.cosh(x/2)/(2*np.sinh(x/2)**5) - 15*(x*np.cosh(x) - 4*np.sinh(x/2)*np.cosh(x/2) + np.sinh(x))*np.cosh(x/2)**3/(2*np.sinh(x/2)**7) - (x*np.cosh(x) - 4*np.sinh(x/2)*np.cosh(x/2) + 3*np.sinh(x))*np.cosh(x/2)/np.sinh(x/2)**5 - 3*(x*np.sinh(x) - 2*np.sinh(x/2)**2 - 2*np.cosh(x/2)**2 + 2*np.cosh(x))/(4*np.sinh(x/2)**4) + 15*(x*np.sinh(x) - 2*np.sinh(x/2)**2 - 2*np.cosh(x/2)**2 + 2*np.cosh(x))*np.cosh(x/2)**2/(4*np.sinh(x/2)**6) + (x*np.sinh(x) - 2*np.sinh(x/2)**2 - 2*np.cosh(x/2)**2 + 4*np.cosh(x))/(8*np.sinh(x/2)**4)
def E_c(N,C_sigma):
    return (N-1)/N * e*e/C_sigma
def u_n(N,C_sigma,T):
    return E_c(N,C_sigma) / k_B / T
def v_n(V,N,T):
    return e*V/N/k_B/T
def G_first_order_zero(T,Gt,N,C_sigma):
    return Gt * (1.0-1.0/6.0 *  u_n(N,C_sigma,T))
def G_second_order_zero(T,Gt,N,C_sigma):
    uN = u_n(N,C_sigma,T)
    return Gt * (1.0-  ( uN/6.0 - uN**2/60     )  )
def G_third_order_zero(T,Gt,N,C_sigma):
    uN = u_n(N,C_sigma,T)
    return Gt * (1.0-  ( uN/6.0 - uN**2/60 + uN**3 / 630    )  )
def G_first_order(V,T,Gt,N,C_sigma,V_offset):
    V = V-V_offset
    vn = v_n(V,N,T)
    un = u_n(N,C_sigma,T)
    with np.errstate(divide='ignore', invalid='ignore'):
        a = 1- un* g(vn)
        return np.where( np.abs(vn)> 1e-3,  Gt * ( a ), G_first_order_zero(T,Gt,N,C_sigma)  )
def G_second_order(V,T,Gt,N,C_sigma,V_offset):
    V = V-V_offset
    vn = v_n(V,N,T)
    un = u_n(N,C_sigma,T)
    with np.errstate(divide='ignore', invalid='ignore'):
        a = 1- un* g(vn)
        b = -1.0/4*un**2 *(   gpp(vn)*h(vn) + gp(vn)*hp(vn) ) 
        return np.where( np.abs(vn)> 1e-2,  Gt * ( a+b ), G_second_order_zero(T,Gt,N,C_sigma)  )
def G_third_order(V,T,Gt,N,C_sigma,V_offset):
    V = V-V_offset
    vn = v_n(V,N,T)
    un = u_n(N,C_sigma,T)
    with np.errstate(divide='ignore', invalid='ignore'):
        a = 1- un* g(vn)
        b = -1.0/4*un**2 *(   gpp(vn)*h(vn) + gp(vn)*hp(vn) ) 
        c = -1.0/8.0*un**3 * (  1.0/4.0*gpppp(vn) * h(vn)**2 + 1.0/3.0*gpp(vn) + 1.0/2.0*gppp(vn)*hp(vn)*h(vn)  )
        return np.where( np.abs(vn)> 5e-2,  Gt * ( a+b+c ), G_third_order_zero(T,Gt,N,C_sigma)  )

def G_third_order_nonisothermal(V,T,Gt,N,C_sigma,V_offset,k):
    V = V-V_offset
    T = T + k*V**2
    vn = v_n(V,N,T)
    un = u_n(N,C_sigma,T)
    with np.errstate(divide='ignore', invalid='ignore'):
        a = 1- un* g(vn)
        b = -1.0/4*un**2 *(   gpp(vn)*h(vn) + gp(vn)*hp(vn) ) 
        c = -1.0/8.0*un**3 * (  1.0/4.0*gpppp(vn) * h(vn)**2 + 1.0/3.0*gpp(vn) + 1.0/2.0*gppp(vn)*hp(vn)*h(vn)  )
        return np.where( np.abs(vn)> 5e-2,  Gt * ( a+b+c ), G_third_order_zero(T,Gt,N,C_sigma)  )

def temperature_from_dip(G,Gt,N,C_sigma):
    """this is the approx solution to G_third_order_zero to find temperature.
    We had to add an additional /N becuase of a typo in the paper. """
    dG = (Gt - G) / Gt
    return E_c(N,C_sigma) / k_B* ( 1.0/dG / 6.0 - 1.0/10.0 - 1.0/350*dG + 27.0/875.0*dG**2  )
    
#imported from pyCBT
n_max=330
def fii(n,C_sigma):
    return n*e/C_sigma
def DF1plus(n,V,C_sigma):
    return (e/2.0)*(fii(n,C_sigma)+fii(n+1,C_sigma)-(V))
def DF1minus(n,V,C_sigma):
    return (e/2.0)*(V-(fii(n,C_sigma)+fii(n-1,C_sigma)))
def DF2plus(n,V,C_sigma):
    return (e/2.0)*(-V-(fii(n,C_sigma)+fii(n-1,C_sigma)))
def DF2minus(n,V,C_sigma):
    return (e/2.0)*((fii(n,C_sigma)+fii(n+1,C_sigma))+V)
def gamma1plus(n,V,T,R_T,C_sigma):
    if (abs(DF1plus(n,V,C_sigma)/(k*T))>1e-12):
        return -1.0/(e**2*R_T)*DF1plus(n,V,C_sigma)/(1.0-np.exp(DF1plus(n,V,C_sigma)/(k*T)))
    else:
        return -k*T/(e**2*R_T)*1.0
def gamma1minus(n,V,T,R_T,C_sigma):
    if (abs(DF1minus(n,V,C_sigma)/(k*T))>1e-12):
        return -1.0/(e**2*R_T)*DF1minus(n,V,C_sigma)/(1.0-np.exp(DF1minus(n,V,C_sigma)/(k*T)))
    else:
        return -k*T/(e**2*R_T)*1.0
def gamma2plus(n,V,T,R_T,C_sigma):
    if (abs(DF2plus(n,V,C_sigma)/(k*T))>1e-12):
        return -1.0/(e**2*R_T)*DF2plus(n,V,C_sigma)/(1.0-np.exp(DF2plus(n,V,C_sigma)/(k*T)))
    else:
        return -k*T/(e**2*R_T)*1.0
def gamma2minus(n,V,T,R_T,C_sigma):
    if (abs(DF2minus(n,V,C_sigma)/(k*T))>1e-12):
        return -1.0/(e**2*R_T)*DF2minus(n,V,C_sigma)/(1.0-np.exp(DF2minus(n,V,C_sigma)/(k*T)))
    else:
        return -k*T/(e**2*R_T)*1.0
def calc_current(V,T,R_T,C_sigma):
    """
    calculates current when voltage V is over 2 (two) junctions
    """
    sigma=np.array([1.0])
    sigma2 = 1.0/((gamma1plus(-1,V,T,R_T,C_sigma)+gamma2minus(-1,V,T,R_T,C_sigma)+gamma1minus(1,V,T,R_T,C_sigma)+gamma2plus(1,V,T,R_T,C_sigma))/(gamma1plus(0,V,T,R_T,C_sigma)+gamma1minus(0,V,T,R_T,C_sigma)+gamma2plus(0,V,T,R_T,C_sigma)+gamma2minus(0,V,T,R_T,C_sigma)))
    sigma=np.append(sigma,sigma2)
    ref_curr = sigma[0]*(gamma1plus(0,V,T,R_T,C_sigma)-gamma1minus(0,V,T,R_T,C_sigma))
    current = ref_curr + sigma[1]*((gamma1plus(1,V,T,R_T,C_sigma)-gamma1minus(1,V,T,R_T,C_sigma))+(gamma1plus(-1,V,T,R_T,C_sigma)-gamma1minus(-1,V,T,R_T,C_sigma)))
    stop_calculation = False # stop further calculation
    for n in range(2,n_max+1):
        if stop_calculation==False:
            sigma2 = -((gamma1plus(n-2,V,T,R_T,C_sigma)+gamma2minus(n-2,V,T,R_T,C_sigma))*sigma[n-2]-(gamma1plus(n-1,V,T,R_T,C_sigma)+gamma1minus(n-1,V,T,R_T,C_sigma)+gamma2plus(n-1,V,T,R_T,C_sigma)+gamma2minus(n-1,V,T,R_T,C_sigma))*sigma[n-1])/(gamma1minus(n,V,T,R_T,C_sigma)+gamma2plus(n,V,T,R_T,C_sigma))           
            sigma=np.append(sigma,sigma2)
            current_curr_plus = sigma[n]*(gamma1plus(n,V,T,R_T,C_sigma)-gamma1minus(n,V,T,R_T,C_sigma))
            current_curr_minus = sigma[n]*(gamma1plus(-n,V,T,R_T,C_sigma)-gamma1minus(-n,V,T,R_T,C_sigma))
            if abs((abs(current_curr_plus+current_curr_minus))/ref_curr)<1e-11: # criteria for stopping calculation
                stop_calculation=True
            current += current_curr_plus + current_curr_minus
    sigma_sum = sigma[0]+2*np.sum(sigma[1:])
    current = current/sigma_sum*e
    return current
def G_simulation_element(V,T,Gt,N,C_sigma,V_offset,excitation = 1e-10):
    V = V-V_offset
    R_T = 1/Gt/N
    eps = excitation/2
    v  = [V+2*eps,V+1*eps,V-1*eps,V-2*eps]
    I =  [calc_current(vi/N*2,T,R_T,C_sigma*N/(N-1))  for vi in v  ]
    return  (-I[0]+8.0*I[1]-8.0*I[2]+I[3])/(12.0*eps)
G_simulation = np.vectorize(G_simulation_element)
